#include <stdio.h>
#include <math.h>

#define min(a,b) (lesq(a,b)?a:b)

const long double Z=1E-9;

int lesq(long double a,long double b)
{
  if (a<=b+Z) return 1;
  return 0;
}

int grt(long double a,long double b)
{
  if (a>b+Z) return 1;
  return 0;
}


int cnt(long double a,long double b,long double h,long double w)
{
  long double d;
  long double L,B,G;
  long double h1,h2,w1,w2;
  
  if (lesq(a,h) && lesq(b,h)) 
  {
    if (lesq(b,w) || lesq(a,w)) return 1;
    return 0;
  }
  if (grt(b,h) && grt(a,h)) return 0;

  d=sqrt(a*a+b*b);
  L=asin(h/d);
  B=2*atan(a/b);
  G=L-B;
  
  h1=fabs(d*sin(L));
  h2=fabs(d*sin(G));  
  w1=fabs(d*cos(L));
  w2=fabs(d*cos(G));
  
  if (lesq(h1,h) && lesq(h2,h) && lesq(w1,w) && lesq(w2,w)) 
    return 1;
  return 0;
}



int main()
{
  int T;
  
  int A,B,X,Y,t;
  scanf("%d",&T);
  while (T--)
  {
    scanf("%d%d%d%d",&A,&B,&X,&Y);
    if (A>B)
    {
     t=A;
     A=B;
     B=t;
    }
    if (X>Y)
    {
      t=X;
      X=Y;
      Y=t;
    }
    printf((cnt(X,Y,A,B) || cnt(Y,X,B,A))?"Escape is possible.\n":"Box cannot be dropped.\n");
  }  
  

  return 0;
}

