#include <stdio.h>
#include <math.h>

double Br[1000];
double Bi[1000];
double hyp[1000];
int maxn;

int values[1000];

double ZERO = 1E-14;
double ZERO2 = 1E-10;

int natural(double x) {
  if (fmod(x+ZERO2,1) < 2*ZERO2) return 1;
  return 0;
}

int solve(double xr, double xi, int maxn, int j) {
  if (j>=maxn) return 0;
  double h = hypot(xr,xi);
//  for(int i=0;i<=maxn;i++) {
//    printf("%lf %lf %lf\n", xr, xi, h);
    int val;
    int ok=0;
    double nxr, nyr;
    double lastv2;
    int nq=ceil(hyp[1]);
    double skok=6;
    for(val=0;val < nq-ZERO;) {
      double vvv = ((xr-val)*(xr-val)+xi*xi)/hyp[1]/hyp[1];
//      printf("v%d %lf ",val, vv*vv);
      if (natural(vvv)) {
//        printf("%d ",val);
//	int k = (int)((hypot(xr-val,xi)+ZERO)/hyp[1]);
	double xx = xr - val;
	double yy = xi;
//	k=1;
	nxr = (xx*Br[1] + yy*Bi[1]) / (Br[1]*Br[1] + Bi[1]*Bi[1]);
	nyr = (-xx*Bi[1] + yy*Br[1]) / (Br[1]*Br[1] + Bi[1]*Bi[1]);
	if (natural(nxr) && natural(nyr)) {
//        printf("+%d ",val);
	  ok=1;
          int r = rint(nxr);
          int i = rint(nyr);
          double qxr = rint(nxr);double qxi=rint(nyr);
//      printf ("%lf %lf %lf %lf\n",qxr, , xr,xi);
	values[j]=val;
      if (r==0 && i==0) return 1;
	  int result = solve(qxr, qxi, maxn, j+1);
	  if (result) return 1;
	  break;
	}
      };
      
/*      int skok=1;
      int last=1;
      for(int v3 = 100; v3 + val < nq; v3*=10) {
	double sw = hypot(xr-val-v3,xi)/hyp[1];
//	printf("%lf %lf\n",sw*sw, vv*vv);
	if (fabs(floor(sw*sw + ZERO)-floor(vv*vv + ZERO)) > ZERO2) break;
	else {
	  last = v3;
//	  printf("BOO (%d, %d)",val+last, nq);
	 }
      }
*///      val+=last;
      val++;
    }
    return 0;
//    if (!ok) return 0;
//    values[i]=val;
 
 
         
/*    
      int r = rint(nxr);
      int i = rint(nyr);
      xr = rint(nxr);xi=rint(nyr);
//      printf ("%lf %lf %lf %lf\n",nxr, nyr, xr,xi);
      if (r==0 && i==0) return 1;
      h = hypot(xr,xi);
//  }
  return 0;
//  printf("%lf %lf %lf\n",xr,xi,h);
//  if (hypot(xr,xi) <= ZERO2) return 1;
//  else return 0;
*/
};    
  
void initb(double br, double bi) {
  double h = hypot(br,bi);
//  printf("%lf %lf %lf\n",br,bi,h);
  
  Br[0]=1;Bi[0]=0;hyp[0]=1;
  maxn=0;
  for(int i=1;i<=100;i++) {
    hyp[i]=hyp[i-1]*h;
//    if (i<10) printf("%d ",(int)hyp[i]);
    Br[i]=Br[i-1]*br - Bi[i-1]*bi;
    Bi[i]=Br[i-1]*bi + Bi[i-1]*br;
    if (hyp[i] >= 20000000.0) break;
    maxn=i;
  }
}

int main(void) {
  int d;
  scanf("%d",&d);
  while (d--) {
    int xr,xi,br,bi;
    scanf("%d %d %d %d",&xr, &xi, &br, &bi);
    initb (br,bi);
    for(int i=0;i<=100;i++)
      values[i]=0;
    if (solve(xr,xi,maxn,0)) {
        int w;
//	printf("OK");
	for(w=maxn;w>0 && values[w]==0;w--);
        for(int i=w;i>=0;i--) {
	  if (i<w) putchar(',');
	  printf("%d",values[i]);
	}
        putchar('\n');
    }
    else printf("The code cannot be decrypted.\n");
  }
  return 0;
}